
set form [ns_getform]

set requestNumber [ns_set get $form requestNumber]

set oldTransparentList [ns_set get $form transparentList]
set oldCloakingList [ns_set get $form cloakingList]

set requestInfo [tt_get_request_info $requestNumber]
foreach {requestLine startTime finishTime duration statementCount stringSpace} $requestInfo break

set result "<html>
<head>
<title>Request #${requestNumber} Statistics</title>
</head>
<body bgcolor=#FFFFFF>

<h2>Request #${requestNumber} Statistics</h2>

<hr>

<table>
<tr><th align=left>Request Line:</th><td>$requestLine</td></tr>
<tr><th align=left>Start Time:</th><td>$startTime</td></tr>
<tr><th align=left>Finish Time:</th><td>$finishTime</td></tr>
<tr><th align=left>Duration:</th><td>$duration</td></tr>
<tr><th align=left>Statements:</th><td>$statementCount</td></tr>
<tr><th align=left>String Space:</th><td>$stringSpace</td></tr>
</table>

<a href=\"trace.tcl?requestNumber=$requestNumber\">View raw trace</a>

<table>
<tr><th bgcolor=#DDDDDD>Command</th>
    <th bgcolor=#AAAAFF>Calls</th>
    <th bgcolor=#DDDDDD>'Local' Time</th>
    <th bgcolor=#AAAAFF>Total Time</th>
    <th bgcolor=#DDDDDD>Child Time</th>
    <th bgcolor=#AAAAFF>Average 'Local' Time</th></tr>"

set localTotal 0.0

set oldTransparentString [ns_urlencode $oldTransparentList]
set oldCloakingString [ns_urlencode $oldCloakingList]

foreach statRec [tt_get_request_statistics $requestNumber $oldTransparentList $oldCloakingList] {
    foreach {cmd callCount totalTime childTime localTime avgLocalTime totalKids avgKids} $statRec break
    
    set transparentList $oldTransparentList
    lappend transparentList $cmd
    set transparentLink "request.tcl?requestNumber=$requestNumber&transparentList=[ns_urlencode $transparentList]&cloakingList=$oldCloakingString"
    
    set cloakingList $oldCloakingList
    lappend cloakingList $cmd
    set cloakingLink "request.tcl?requestNumber=$requestNumber&transparentList=$oldTransparentString&cloakingList=[ns_urlencode $cloakingList]"

    set localTotal [expr $localTotal + $localTime]
        
    append result "
<tr><td bgcolor=#DDDDDD>$cmd<br><small>\[<a href=\"$transparentLink\">transparent</a> | <a href=\"$cloakingLink\">cloak</a>\]</small></td>
    <td bgcolor=#AAAAFF>$callCount</td>
    <td bgcolor=#DDDDDD>[format %7.6f $localTime]</td>
    <td bgcolor=#AAAAFF>[format %7.6f $totalTime]</td>
    <td bgcolor=#DDDDDD>[format %7.6f $childTime]</td>
    <td bgcolor=#AAAAFF>[format %7.6f $avgLocalTime]</td>"
}

append result "
</table>
<br>
Local time error: [expr $localTotal - $duration]
</body>
</html>"

ns_return 200 text/html $result